'use strict';
const fs      = require('fs');
const co      = require('co');
const _       = require('lodash');
const lib     = require('./lib');
const nconf   = require('nconf');
const yaml    = require('js-yaml');

require('http').globalAgent.maxSockets = 1000;

function configOverides( ) {
  let config = {};
  const paths = [
    '/etc/s3-move.yaml',
    's3-move.yaml'
  ];

  let content = '';
  for( let path of paths ) {
    try {
      content = fs.readFileSync( path, 'utf8' );
    } catch( err ) {}
    _.merge( config, yaml.load( content ) );
  }

  return config;
}

nconf
.argv()
.env()
.overrides( configOverides() )
.defaults({
  concurrency : 2,
  event : 'add'
});

co( main ).then( handleSuccess ).catch( handleError );

function *main() {
  yield lib( nconf.get() );
}

function handleSuccess( value ) {
  console.log( value );
  process.exit( 0 );
}

function handleError( error ) {
  console.log( error );
  process.exit( 1 );
}

